variables:
  JOB_HELM_IMAGE: "registry.gitlab.com/operator-ict/golemio/devops/helm/main:1.30.3-3.15.3"

# expects DOCKER_COMPOSE_FILE, SWARM_SERVICE, SERVICE_TAG, GIT_PUSH_TOKEN
# optional: SKIP_LATEST_VERSION_WRITE
.update-docker-swarm-tag:
  variables:
    GIT_EMAIL: "webapps-robot@operatorict.cz"
    GIT_USERNAME: "webapps-robot"
  image: $JOB_HELM_IMAGE
  script:
#    - set -x
    - |
        echo $DOCKER_COMPOSE_FILE;
        echo $SWARM_SERVICE;
        echo $SERVICE_TAG;
        if [[ -z "$DOCKER_COMPOSE_FILE" ]] || [[ -z "$SWARM_SERVICE" ]] || [[ -z "$SERVICE_TAG" ]]; then 
          echo "Jedna nebo více environmentálních proměnných (DOCKER_COMPOSE_FILE, SWARM_SERVICE, SERVICE_TAG) nejsou nastaveny.";
          exit 1;
        fi
    - if $CI_COMMIT_REF_PROTECTED ; then echo "Ok, this branch is protected."; else echo "This branch is not protected!";exit 1; fi
    - COMMAND="yq eval --inplace '.services.${SWARM_SERVICE}.image |= sub(\":.*$\"; \":${SERVICE_TAG}\")' ${DOCKER_COMPOSE_FILE}"
    - echo $COMMAND
    - eval $COMMAND
    - if [ -n "$SKIP_LATEST_VERSION_WRITE" ] ; then exit 0; fi
    - git config --global user.email "$GIT_EMAIL"
    - git config --global user.name "$GIT_USERNAME"
    - git config --global --add safe.directory '*'
    - git add $DOCKER_COMPOSE_FILE
    - git remote set-url --push origin https://gitlab-ci-token:${GIT_PUSH_TOKEN}@gitlab.com/$CI_PROJECT_PATH.git
    - git pull origin $CI_COMMIT_REF_NAME
    - git commit -m "autocommit - update image tag for $DOCKER_COMPOSE_FILE, service $SWARM_SERVICE"
    - git push -o ci.skip origin HEAD:$CI_COMMIT_REF_NAME
# #artifact path tady nefunguje dobre, protoze se sestavuje az ve script a je potreba ji definovat u odvozeneho jobu
#  artifacts:
#    paths:
#      - ${YQ_FILE}
#    expire_in: 2 day
#  rules:
#    - if: $CI_PIPELINE_SOURCE == "pipeline"
